<script setup>
    const props = defineProps({
        list : {
            type: Array,
            required: true
        },
        selected : {
            type: Array,
            default: []
        },
        tailleElement: {
            type: Number,
            default: NaN
        }
    });

    const emit = defineEmits(["add", "remove"]);

    const filtered_list = ref([]);
    const filter_value = ref("");
    const is_filter_activated = computed(() => {
        return filter_value.value.trim() != "";
    });

    function setFilter(e) {
        filter_value.value = e.target.value;
        filtered_list.value = filterByName(props.list, filter_value.value);
    }

    function emitChoice(element, select) {
        if(select) {
            emit("add", element);
        }
        else {
            emit("remove", element);
        }
    }

</script>
<template>
    <div>
        <!-- Search bar -->
        <div class="w-full flex flex-row p-2 space-x-2">
            <img src="/images/search.svg" width="20px" height="20px">
            <input @input="setFilter" :value="filter_value" type="text" class="w-full">
        </div>
        <!-- Choices list -->
        <div class="h-[210px] overflow-y-auto overflow-x-hidden flex flex-col bg-las-orange rounded-b-[10px] p-2">
            <ul v-if="is_filter_activated" class="list-none">
                <FormSearchListElement v-for="element in filtered_list" :name="element.name" :is_selected="selected.includes(element.name)" @select="(select) => emitChoice(element, select)" />
            </ul>
            <ul v-else class="list-none">
                <FormSearchListElement v-for="element in list" :name="element.name" :is_selected="selected.includes(element.name)" :taille="tailleElement" @select="(select) => emitChoice(element, select)" />
            </ul>
        </div>
    </div>
</template>